/*M*
//                    INTEL CORPORATION PROPRIETARY INFORMATION
//      This software is supplied under the terms of a license agreement or
//      nondisclosure agreement with Intel Corporation and may not be copied
//      or disclosed except in accordance with the terms of that agreement.
//            Copyright (c) 1999 Intel Corporation.  All Rights Reserved.
//
//
//			The purpose of this file is to capture some of the typdefs and
//		#defines that are used by the NT driver and which are not in the 
//		Linux kernel headers. This avoids changing the NT driver code on which
//		the linux driver is based.
//
//  PVCS:
//      $Workfile:   windefs.h  $
//      $Revision:   1.1  $
//      $Modtime:   25 Apr 2000 13:42:36  $
//      $Author:   mramacha  $
//      $Log:   //cospublic004/shareddata/ISC/ISC2x/LNWORK/SRC/NTIO/INC/windefs.h.v  $
 * 
 *    Rev 1.1   25 Apr 2000 12:40:32   mramacha
 * Added Max_PATH that was missing and needed
 * by sfsnew.
 * 
 *    Rev 1.0   24 Apr 2000 17:06:06   mramacha
 * Initial checkin
//
*M*/



#ifndef	_WINDEFS_H
#define	_WINDEFS_H

#ifndef NULL
#define NULL 0
#endif

#ifdef __KERNEL__

typedef long NTSTATUS;
#define	NT_SUCCESS(status)		((NTSTATUS)(status) >= 0)

#define STATUS_SUCCESS                   ((NTSTATUS)0x00000000L)
#define STATUS_UNSUCCESSFUL              ((NTSTATUS)0xC0000001L)

#endif


#ifndef FALSE
#define FALSE   0
#endif
#ifndef TRUE
#define TRUE    1
#endif
#ifndef NULL
#define NULL 0
#endif


#ifndef _WCHAR_T
#define _WCHAR_T
typedef long    wchar_t;
#endif


#define far
#define near
#define FAR                 far
#define NEAR                near
#ifndef CONST
#define CONST               const
#endif

typedef unsigned long       DWORD;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef float               FLOAT;
typedef FLOAT               *PFLOAT;
typedef BOOL near           *PBOOL;
typedef BOOL far            *LPBOOL;
typedef BYTE near           *PBYTE;
typedef BYTE far            *LPBYTE;
typedef int near            *PINT;
typedef int far             *LPINT;
typedef WORD near           *PWORD;
typedef WORD far            *LPWORD;
typedef long far            *LPLONG;
typedef DWORD near          *PDWORD;
typedef DWORD far           *LPDWORD;
typedef void far            *LPVOID;
typedef CONST void far      *LPCVOID;

typedef int                 INT;
typedef unsigned int        UINT;
typedef unsigned int        *PUINT;

/*
  File structures
*/

typedef struct _OVERLAPPED {
    DWORD   Internal;
    DWORD   InternalHigh;
    DWORD   Offset;
    DWORD   OffsetHigh;
/*    HANDLE  hEvent; */
} OVERLAPPED, *LPOVERLAPPED;

/*
 * NT data structure redefines
 */
typedef char CHAR;
typedef short SHORT;
typedef long LONG;
typedef char * PCHAR;
typedef short * PSHORT;
typedef long * PLONG;
typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;
typedef unsigned char * PUCHAR;
typedef unsigned short * PUSHORT;
typedef unsigned long * PULONG;
typedef char CCHAR;
typedef short CSHORT;
typedef ULONG CLONG;
typedef CCHAR * PCCHAR;
typedef CSHORT * PCSHORT;
typedef CLONG * PCLONG;
typedef void VOID;
typedef void * PVOID;
typedef struct _LARGE_INTEGER {
	ULONG LowPart;
	LONG HighPart;
} LARGE_INTEGER;
typedef LARGE_INTEGER * PLARGE_INTEGER;
typedef LARGE_INTEGER PHYSICAL_ADDRESS;
typedef LARGE_INTEGER * PPHYSICAL_ADDRESS;
typedef struct _ULARGE_INTEGER {
	ULONG LowPart;
	ULONG HighPart;
} ULARGE_INTEGER;
typedef ULARGE_INTEGER * PULARGE_INTEGER;

/*
 Boolean
*/

typedef UCHAR BOOLEAN;
typedef BOOLEAN *PBOOLEAN;

typedef wchar_t		    WCHAR;
typedef WCHAR		    *PWCHAR, *PWSTR;
typedef CONST WCHAR	    *LPCWSTR, *PCWSTR;

/*
 Unicode strings are counted 16-bit character strings. If they are
 NULL terminated, Length does not include trailing NULL.
*/

typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
    PWSTR  Buffer;
} UNICODE_STRING;
typedef UNICODE_STRING *PUNICODE_STRING;
#define UNICODE_NULL ((WCHAR)0) /* winnt*/

#define IN	/* */
#define OUT	/* */
#define OPTIONAL	/* */
#define UNREFERENCED_PARAMETER(x)
#define FIELD_OFFSET(type, field)    ((LONG)&(((type *)0)->field))
typedef	int HANDLE;
typedef	HANDLE	*PHANDLE;
#define	INVALID_HANDLE_VALUE	((HANDLE)-1)



/*
 Define the method codes for how buffers are passed for I/O and FS controls
*/

#define METHOD_BUFFERED                 0

/*
 Define the access check value for any access


 The FILE_READ_ACCESS and FILE_WRITE_ACCESS constants are also defined in
 ntioapi.h as FILE_READ_DATA and FILE_WRITE_DATA. The values for these
 constants *MUST* always be in sync.
*/

#define FILE_ANY_ACCESS                 0

/*
  These are the generic rights.
*/

#define    MAX_PATH        260

#define	GetLastError()	(NTstatus.Status)



/*
 Macro definition for defining IOCTL and FSCTL function control codes.  Note
 that function codes 0-2047 are reserved for Microsoft Corporation, and
 2048-4095 are reserved for customers.
*/

/*
 * Linux drivers expect ioctls defined using macros defined in ioctl.h.
 * So, instead of using the CTL_CODE defined for NT and UW, I define CTL_CODE
 * using these macros. That way imb_if.h, where the ioctls are defined get
 * to use the correct ioctl command we expect. 
 * Notes: I am using the generic _IO macro instead of the more specific
 * ones. The macros expect 8bit entities, so I am cleaning what is sent to
 * us from imb_if.h Mahendra
 */

#ifdef LINUX
#define CTL_CODE(DeviceType, Function, Method, Access)\
		_IO(DeviceType & 0x00FF, Function & 0x00FF)
#else
#define CTL_CODE( DeviceType, Function, Method, Access ) ((ULONG)(	\
    ((ULONG)(DeviceType) << 16) | ((ULONG)(Access) << 14) | ((ULONG)(Function) << 2) | ((ULONG)Method) \
))
#endif


#endif //_WINDEFS_H

